
--1. Criao do campo
IF NOT EXISTS (SELECT 1 FROM SYS.COLUMNS C 
INNER JOIN SYS.TABLES T ON T.OBJECT_ID = C.OBJECT_ID 
WHERE T.NAME = 'TB_PARCELA'
 AND C.NAME = 'PAR_ORIGEM_PARCELA') 
ALTER TABLE TB_PARCELA ADD PAR_ORIGEM_PARCELA VARCHAR (255)  NULL 
CONSTRAINT DF_PAR_ORIGEM_PARCELA DEFAULT 'GERACAO_PARCELA' 
GO



--2. Atualizao do campo com valor padro. Este script pode ser extremanente demorado, mas no ir travar o banco, pois executa de 100 em 100. 
--No deve fechar a aba do sql server at a sua concluso
 
DECLARE @RowCount INT = 1;
WHILE @RowCount > 0
BEGIN
    -- Atualiza os prximos 100 registros
    UPDATE TOP(100) TB_PARCELA
    SET PAR_ORIGEM_PARCELA = 'GERACAO_PARCELA'
    WHERE PAR_ORIGEM_PARCELA IS NULL
    -- Atualiza a contagem de registros afetados
    SET @RowCount = @@ROWCOUNT;
END


--3. Ao finalizar o script acima, rodar a query abaixo, ela dever retornar 0 registros, caso contrrio, executar a query acima novamente.
SELECT COUNT(*) FROM TB_PARCELA WHERE PAR_ORIGEM_PARCELA IS NULL
 

--4. Caso a query do item 3 retorne 0 registros, dever rodar o script abaixo para atualizao do campo para not null
ALTER TABLE TB_PARCELA ALTER COLUMN PAR_ORIGEM_PARCELA VARCHAR (255) NOT NULL